// SYMPLECTIC INTEGRATOR 6TH OERDER YOSHIDA

#ifndef _SYMPLECTIC6_H_
#define _SYMPLECTIC6_H_

extern int SINITIALIZED;
extern double Dt0; //initial time step

typedef struct BS_CONFIG {
	double acc;
	double dt0;
	double dtmin;
	double dtmax;
	int neqerr;
} BSVAR;

extern void(*derivs)(double, double[], double[]);

int InitSI(int numeq, double dt);
void CloseSI();

// Checking for STAR
void Symplectic6thRUN(double yin[], int N, double dt, double yout[]); // Symplectic Integrator Yoshida 6th Order


#endif
