//gTOOLS.cpp 
//Version 1.0,  20/2/07   //based on pTools - version 1.0, 1/3/05
//revised 30/1/2012 : allocation NxN memory of integers

#pragma warning (disable : 4996)

#include <nbody\gTools.h>


//=======================================================
// SET 1 : 2D-arrays
//=======================================================

//1.1 Memory Allocation 

double ** Alloc2Dspace(int rows, int columns)
//Return pointer at rows x columns space of double floats
{

	double **DD;
	DD = new double*[rows]; //pointers for each row  (first element)
	for (int i = 0; i<rows; i++) DD[i] = new double[columns];  //space for each row
	if (DD == NULL) return 0;
	for (int i = 0; i<rows; i++) if (DD[i] == NULL) return 0;
	return DD;
}

void Delete2Dspace(double **DD, int rows)
//Clear 2D memory space of double floats
{
	for (int i = 0; i<rows; i++) delete[] DD[i];  //delete space for each row 
	delete[] DD; //delete array of pointers to rows
}


int ** Alloc2DspaceIntegers(int rows, int columns)
//Return pointer at rows x columns space of double floats
{

	int **DD;
	DD = new int*[rows]; //pointers for each row  (first element)
	for (int i = 0; i<rows; i++) DD[i] = new int[columns];  //space for each row
	if (DD == NULL) return 0;
	for (int i = 0; i<rows; i++) if (DD[i] == NULL) return 0;
	return DD;
}

void Delete2Dspace(int **DD, int rows)
//Clear 2D memory space of double floats
{
	for (int i = 0; i<rows; i++) delete[] DD[i];  //delete space for each row 
	delete[] DD; //delete array of pointers to rows
}



//=======================================================
//  SET 2 : ASCII FILES 
//=======================================================

//2.1 read chars until '='
void Readfstr(FILE *fil)
{
	char c;	do { fscanf(fil, "%c", &c); } while (c != '=' && !feof(fil));
}

//2.2 read string (get until end of line)
void Readstring(FILE *fil, char *slabel)
{
	char c;	int n = 0; fscanf(fil, "%c", &c);
	if (c != ' ') slabel[n++] = c;
	do
	{
		fscanf(fil, "%c", &c); slabel[n++] = c;
	} while (c != '\n'&&n<128);
	slabel[n - 1] = '\0';
}
