//DSYSTEM :  NBV project 
//30/1/2012




#ifndef _DSYSNBS_H
#define _DSYSNBS_H

#include <math.h>
#include "Symp6s.h"
#include "gTools.h"

#define CMFREE 0  //DO NOT CHANGE
//#define NB 2  //number of bodies (not include S-BODY) 
//#define NDOF 6 //number of Degrees of freedom (NBx3)
//#define NEQ 25 //number of 1st order deqs+1 = NDOFx4+1 //includes variational equations 

//========Global system variables ==================
extern int NB, NDOF, NEQ;
extern double *mas, mtot; //masses //0 pos stands for mass of SUN
//extern double *XS;  //Sun pos vector

//int InitDSys(int Nbodies, double m[], BSVAR bs);
int InitDSys(int NB, double m[], double dt);
void FreeDSys();

void InitVariations0(double X0[],int mode);

void SBodyPos(double X[], double XS[]);

//integrals
void AngularMomentumBody(int i, double X[], double *Lx, double *Ly, double *Lz);	
double AngularMomentum(double X[], double *Lx, double *Ly, double *Lz);
double AngularMomentum(double X[]);
double KineticEnergyBody(int i, double X);
double Energy(double X[]);
//Chaoticity indices
double CalcDFLI(double X[]);



#endif

