//NBS project
//*************************** N planets + Sun ********************
//26/3/07  


#include "restroe3.h"

#ifndef _IROENBS_H
#define _IROENBS_H 

typedef struct ResonantAngles   //always in Deg
{
	double th1;
	double th2;
	double sig1;
	double sig2;
	double Dom;
	double resonance;
} Rangles;


void GetSystemPosV(OEDEF *oeb, double X0[]);  
void GetBodiesOE(double X[], OEDEF Q[]);

void GetBodyPos(int body, double X[], double XB[]);		
void SetSystemPos(int i, double xb[], double X0[]);

void GetRangles(int Pr, int Qr, OEDEF q1, OEDEF q2, Rangles *R, int mode_180_pi);
void FixAngle(double *x, int mode_deg, int mode_180_pi);



#endif